module Math.Test.TestAll where

import Math.Test.TGraph
import Math.Test.TDesign
import Math.Test.TPermutationGroup
import Math.Test.TSubquotients
import Math.Test.TFiniteGeometry
import Math.Test.TCommutativeAlgebra
import Math.Test.TNonCommutativeAlgebra
import Math.Test.TField
import Math.Test.TRootSystem

import Test.QuickCheck

testall = and
    [Math.Test.TGraph.test
    ,Math.Test.TDesign.test
    ,Math.Test.TPermutationGroup.test
    ,Math.Test.TSubquotients.test
    ,Math.Test.TFiniteGeometry.test
    ,Math.Test.TCommutativeAlgebra.test
    ,Math.Test.TField.test
    ,Math.Test.TRootSystem.test
    ]

quickCheckAll =
    do
    quickCheck prop_CommRingMPoly
    quickCheck prop_NonCommRingNPoly
    quickCheck prop_GroupPerm
